package com.sybotan.android.demo.activities

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.webkit.JavascriptInterface
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import com.sybotan.android.demo.R
import com.sybotan.android.demo.bean.model3d.MeshObject
import com.sybotan.android.demo.tools.ToastUtils
import kotlin.reflect.jvm.internal.impl.load.kotlin.JvmType

class Space3DActivity : AppCompatActivity() {

    private lateinit var webview: WebView
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_space3_dactivity)
        webview = findViewById(R.id.webview)
        webview.clearCache(true)
        val settings: WebSettings = webview.settings
        settings.javaScriptEnabled = true
        settings.defaultTextEncodingName = "utf-8"
        settings.builtInZoomControls = true
        settings.loadsImagesAutomatically = true
        settings.layoutAlgorithm = WebSettings.LayoutAlgorithm.SINGLE_COLUMN
        // 是否启动概述模式浏览界面，当页面宽度超过WebView显示宽度时，缩小页面适应WebView。默认false
        settings.loadWithOverviewMode = true
        settings.domStorageEnabled = true
        settings.databaseEnabled = true
        settings.mixedContentMode = WebSettings.MIXED_CONTENT_ALWAYS_ALLOW
        webview.addJavascriptInterface(this, "android")
        webview.webViewClient = MyWebViewClient()
        webview.loadUrl("http://60.205.177.43:8000/APP/#/?PageType=1")
    }

//    @JavascriptInterface
//    fun MeshClick(meshObject: Any) {
//        runOnUiThread {
//            if (meshObject is MeshObject) {
//                val mo = meshObject as MeshObject
//                ToastUtils.showMyToast("选中了ID:${mo.ID}")
//            }
//        }
//    }

    @JavascriptInterface
    fun MeshClick(meshObject: String) {
        runOnUiThread {
            ToastUtils.showMyToast("选中了ID:${meshObject}")
        }
    }

    class MyWebViewClient : WebViewClient() {
        //兼容低版本
        override fun shouldOverrideUrlLoading(view: WebView, url: String): Boolean {
            view.loadUrl(url)
            return true
        }

        override fun onPageFinished(view: WebView, url: String) {
            super.onPageFinished(view, url)
        }
    }
}